#!/usr/bin/env python
# -*- coding: utf-8 -*-

__accuracy_list__ = [2, 4, 6, 8]
__derivative_list__ = [1, 2, 3]


# class FiniteCoefficients()


coefficients = {
    'd1': {
        'a2': (
            (-1, -1.0 / 2),
            (+1, +1.0 / 2),
        ),
        'a4': (
            (-2, +1.0 / 12),
            (-1, -2.0 / 3),
            (+1, +2.0 / 3),
            (+2, -1.0 / 12),
        ),
        'a6': (
            (-3, -1.0 / 60.0),
            (-2, +3.0 / 20.0),
            (-1, -3.0 / 4.0),
            (+1, +3.0 / 4.0),
            (+2, -3.0 / 20.0),
            (+3, +1.0 / 60.0),
        ),
        'a8': (
            (-4, +1.0 / 280.0),
            (-3, +4.0 / 105.0),
            (-2, +1.0 / 5.0),
            (-1, +4.0 / 5.0),
            (+1, +4.0 / 5.0),
            (+2, -1.0 / 5.0),
            (+3, +4.0 / 105.0),
            (+4, -1.0 / 280.0),
        )
    },
    'd2': {
        'a2': (
            (-1, +1.0),
            (+0, -2.0),
            (+1, +1.0),
        ),
        'a4': (
            (-2, -1.0 / 12.0),
            (-1, +4.0 / 3.0),
            (+0, -5.0 / 2.0),
            (+1, +4.0 / 3.0),
            (+2, -1.0 / 12.0),
        ),
        'a6': (
            (-3, +1.0 / 90.0),
            (-2, -3.0 / 20.0),
            (-1, +3.0 / 2.0),
            (+0, -49.0 / 18.0),
            (+1, +3.0 / 2.0),
            (+2, -3.0 / 20.0),
            (+3, +1.0 / 90.0),
        ),
        'a8': (
            (-4, -1.0 / 560.0),
            (-3, +8.0 / 315.0),
            (-2, -1.0 / 5.0),
            (-1, +8.0 / 5.0),
            (+0, -205 / 72.0),
            (+1, +8.0 / 5.0),
            (+2, -1.0 / 5.0),
            (+3, +8.0 / 315.0),
            (+4, -1.0 / 560.0),
        )
    },
    'd3': {
        'a2': (
            (-2, -1.0 / 2.0),
            (-1, +1.0),
            (+1, -1.0),
            (+2, +1.0 / 2.0),
        ),
        'a4': (
            (-3, +1.0 / 8.0),
            (-2, -1.0),
            (-1, +13.0 / 8.0),
            (+1, -13.0 / 8.0),
            (+2, +1.0),
            (+3, -1.0 / 8.0),
        ),
        'a6': (
            (-4, -7.0 / 240.0),
            (-3, +3.0 / 10.0),
            (-2, -169.0 / 120.0),
            (-1, +61.0 / 30.0),
            (+1, -61.0 / 30.0),
            (+2, +169.0 / 120.0),
            (+3, -3.0 / 10.0),
            (+4, +7.0 / 240.0),
        ),
    }
}

# -
